package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.KQ;
import com.sa.ibiz.demo.demo.service.KQService;
import com.sa.ibiz.demo.demo.service.dto.KQSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/kq")
public class KQResource
{
	@Autowired
	private KQService service;


	@PostMapping(value = "/getDraft")
	public ResponseEntity<KQ> getDraft(@Validated @RequestBody KQ data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("考勤[getDraft]操作发生错误","KQ","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<KQ> remove(@Validated @RequestBody KQ data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("考勤[remove]操作发生错误","KQ",data.getKqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<KQ> create(@Validated @RequestBody KQ data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("考勤[create]操作发生错误","KQ",data.getKqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<KQ> get(@Validated @PathVariable String id){
		KQ data=new KQ();
		data.setKqid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("考勤[get]操作发生错误","KQ",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<KQ> checkKey(@Validated @RequestBody KQ data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("考勤[checkKey]操作发生错误","KQ",data.getKqid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<KQ> update(@Validated @RequestBody KQ data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("考勤[update]操作发生错误","KQ",data.getKqid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<KQ>> searchDefaultPage(@Validated @RequestBody KQSearchFilter filter){
		Page<KQ> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<KQ>> listDefault(@Validated @RequestBody KQSearchFilter filter){
		List<KQ> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
